﻿// © 2021 ABBYY Development Inc.
// SAMPLES code is property of ABBYY, exclusive rights are reserved. 
//
// DEVELOPER is allowed to incorporate SAMPLES into his own APPLICATION and modify it under 
// the  terms of  License Agreement between  ABBYY and DEVELOPER.


// ABBYY FineReader Engine 12 Sample

using System;
using FREngine;

namespace FREngineEvents 
{
    public class CFRDocumentEvents
    {
        public static void OnPageProcessed(IFRDocument sender, int index, PageProcessingStageEnum stage)
        {
            Console.WriteLine($"FRDOcumentEvents::OnPageProcessed: {index}: {stage}");
        }

        public static void OnProgress(IFRDocument sender, int percentage, ref bool cancel)
        {
            Console.WriteLine($"FRDocumentEvents::OnProgress: {percentage}");
            cancel = false;
        }
        public static void OnWarning(IFRDocument sender, int pageIndex, string warning, ref bool cancel)
        {
            Console.WriteLine($"FRDocumentEvents::OnWarning: {pageIndex}: {warning}");
            cancel = false;
        }
    }

    public class CFRPagesEvents
    {
        public static void PageAdded(IFRPages sender, int index)
        {
            Console.WriteLine($"FRPagesEvents::PageAdded: {index}");
        }

        public static void PagesRenumbered(IFRPages sender)
        {
            Console.WriteLine("FRPagesEvents::PagesRenumbered");
        }

        public static void PageRemoved(IFRPages sender, IFRPage page, int index)
        {
            Console.WriteLine($"FRPagesEvents::PageRemoved: {index}");
        }
    }

    public class CFRPageEvents
    {
        public static void OnPageProcessed(IFRPage sender, PageProcessingStageEnum stage)
        {
            Console.WriteLine($"FRPageEvents::OnPageProcessed: {stage}");
        }

        public static void OnProgress(IFRPage sender, int percentage, ref bool cancel)
        {
            Console.WriteLine($"FRPageEvents::OnProgress: {percentage}");
            cancel = false;
        }

        public static void OnRegionProcessed(IFRPage sender, int recognitionPassNumber, IRegion region, ref bool cancel)
        {
            Console.WriteLine($"FRPageEvents::OnRegionProcessed: {recognitionPassNumber}");
            cancel = false;
        }

        public static void OnWarning(IFRPage sender, string warning, ref bool cancel)
        {
            Console.WriteLine($"FRPageEvents::OnWarning: {warning}");
            cancel = false;
        }
    }

    public class CImageDocumentEvents
    {
        public static void TransformationMade(RotationTypeEnum rotation, bool wasMirrored, bool wasInverted)
        {
            Console.WriteLine($"ImageDocumentEvents::TransformationMade: {rotation}");
        }
    }


}

