//  2019 ABBYY Development Inc.
// SAMPLES code is property of ABBYY, exclusive rights are reserved. 
//
// DEVELOPER is allowed to incorporate SAMPLES into his own APPLICATION and modify it under 
// the  terms of  License Agreement between  ABBYY and DEVELOPER.


// ABBYY FineReader Engine 12 Sample

using System;
using System.Drawing;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Threading;

namespace Sample
{
    /// <summary>
    /// Summary description for MainForm.
    /// </summary>
    public class MainForm : System.Windows.Forms.Form
    {
        private StatusStrip statusStrip;
        private ToolStripStatusLabel textToolStrip;
        private Panel panelText;
        private Label textLabel;
        private SplitContainer splitContainer;
        private PictureBox pictureBox;
        private Panel goPanel;
        private TreeView traceTreeView;
        private Label threadsLabel;
        private Button goButton;
        private NumericUpDown threadsNumericUpDown;
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private IContainer components = null;

        public MainForm()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            Application.EnableVisualStyles();
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose( bool disposing )
        {
            if( disposing ) {
                if( components != null ) {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
            this.statusStrip = new System.Windows.Forms.StatusStrip();
            this.textToolStrip = new System.Windows.Forms.ToolStripStatusLabel();
            this.panelText = new System.Windows.Forms.Panel();
            this.textLabel = new System.Windows.Forms.Label();
            this.splitContainer = new System.Windows.Forms.SplitContainer();
            this.pictureBox = new System.Windows.Forms.PictureBox();
            this.goPanel = new System.Windows.Forms.Panel();
            this.goButton = new System.Windows.Forms.Button();
            this.threadsNumericUpDown = new System.Windows.Forms.NumericUpDown();
            this.threadsLabel = new System.Windows.Forms.Label();
            this.traceTreeView = new System.Windows.Forms.TreeView();
            this.statusStrip.SuspendLayout();
            this.panelText.SuspendLayout();
            this.splitContainer.Panel1.SuspendLayout();
            this.splitContainer.Panel2.SuspendLayout();
            this.splitContainer.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox)).BeginInit();
            this.goPanel.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.threadsNumericUpDown)).BeginInit();
            this.SuspendLayout();
            // 
            // statusStrip
            // 
            this.statusStrip.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.textToolStrip});
            this.statusStrip.Location = new System.Drawing.Point(0, 540);
            this.statusStrip.Name = "statusStrip";
            this.statusStrip.Size = new System.Drawing.Size(484, 22);
            this.statusStrip.TabIndex = 0;
            this.statusStrip.Text = "Ready";
            // 
            // textToolStrip
            // 
            this.textToolStrip.Name = "textToolStrip";
            this.textToolStrip.Size = new System.Drawing.Size(39, 17);
            this.textToolStrip.Text = "Ready";
            // 
            // panelText
            // 
            this.panelText.Controls.Add(this.textLabel);
            this.panelText.Dock = System.Windows.Forms.DockStyle.Top;
            this.panelText.Location = new System.Drawing.Point(0, 0);
            this.panelText.Name = "panelText";
            this.panelText.Size = new System.Drawing.Size(484, 100);
            this.panelText.TabIndex = 0;
            // 
            // textLabel
            // 
            this.textLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.textLabel.Location = new System.Drawing.Point(12, 12);
            this.textLabel.Name = "textLabel";
            this.textLabel.Size = new System.Drawing.Size(460, 77);
            this.textLabel.TabIndex = 0;
            this.textLabel.Text = resources.GetString("textLabel.Text");
            // 
            // splitContainer
            // 
            this.splitContainer.Dock = System.Windows.Forms.DockStyle.Fill;
            this.splitContainer.Location = new System.Drawing.Point(0, 100);
            this.splitContainer.Name = "splitContainer";
            this.splitContainer.Orientation = System.Windows.Forms.Orientation.Horizontal;
            // 
            // splitContainer.Panel1
            // 
            this.splitContainer.Panel1.Controls.Add(this.pictureBox);
            this.splitContainer.Panel1.Controls.Add(this.goPanel);
            this.splitContainer.Panel1MinSize = 150;
            // 
            // splitContainer.Panel2
            // 
            this.splitContainer.Panel2.Controls.Add(this.traceTreeView);
            this.splitContainer.Panel2MinSize = 150;
            this.splitContainer.Size = new System.Drawing.Size(484, 440);
            this.splitContainer.SplitterDistance = 267;
            this.splitContainer.TabIndex = 0;
            // 
            // pictureBox
            // 
            this.pictureBox.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pictureBox.Location = new System.Drawing.Point(127, 0);
            this.pictureBox.Name = "pictureBox";
            this.pictureBox.Size = new System.Drawing.Size(357, 267);
            this.pictureBox.TabIndex = 0;
            this.pictureBox.TabStop = false;
            this.pictureBox.SizeChanged += new EventHandler(pictureBox_SizeChanged);
            // 
            // goPanel
            // 
            this.goPanel.Controls.Add(this.goButton);
            this.goPanel.Controls.Add(this.threadsNumericUpDown);
            this.goPanel.Controls.Add(this.threadsLabel);
            this.goPanel.Dock = System.Windows.Forms.DockStyle.Left;
            this.goPanel.Location = new System.Drawing.Point(0, 0);
            this.goPanel.Name = "goPanel";
            this.goPanel.Size = new System.Drawing.Size(127, 267);
            this.goPanel.TabIndex = 0;
            // 
            // goButton
            // 
            this.goButton.Location = new System.Drawing.Point(15, 32);
            this.goButton.Name = "goButton";
            this.goButton.Size = new System.Drawing.Size(97, 23);
            this.goButton.TabIndex = 1;
            this.goButton.Text = "Go";
            this.goButton.UseVisualStyleBackColor = true;
            this.goButton.Click += new System.EventHandler(this.goButton_Click);
            // 
            // threadsNumericUpDown
            // 
            this.threadsNumericUpDown.Location = new System.Drawing.Point(67, 6);
            this.threadsNumericUpDown.Name = "threadsNumericUpDown";
            this.threadsNumericUpDown.Size = new System.Drawing.Size(45, 20);
            this.threadsNumericUpDown.TabIndex = 2;
            // 
            // threadsLabel
            // 
            this.threadsLabel.AutoSize = true;
            this.threadsLabel.Location = new System.Drawing.Point(12, 8);
            this.threadsLabel.Name = "threadsLabel";
            this.threadsLabel.Size = new System.Drawing.Size(49, 13);
            this.threadsLabel.TabIndex = 0;
            this.threadsLabel.Text = "Threads:";
            // 
            // traceTreeView
            // 
            this.traceTreeView.Dock = System.Windows.Forms.DockStyle.Fill;
            this.traceTreeView.FullRowSelect = true;
            this.traceTreeView.HideSelection = false;
            this.traceTreeView.Location = new System.Drawing.Point(0, 0);
            this.traceTreeView.Name = "traceTreeView";
            this.traceTreeView.ShowPlusMinus = false;
            this.traceTreeView.ShowRootLines = false;
            this.traceTreeView.Size = new System.Drawing.Size(484, 169);
            this.traceTreeView.TabIndex = 0;
            this.traceTreeView.TabStop = false;
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(484, 562);
            this.Controls.Add(this.splitContainer);
            this.Controls.Add(this.panelText);
            this.Controls.Add(this.statusStrip);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MinimumSize = new System.Drawing.Size(400, 500);
            this.Name = "MainForm";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "FineReader Engines Pool";
            this.statusStrip.ResumeLayout(false);
            this.statusStrip.PerformLayout();
            this.panelText.ResumeLayout(false);
            this.splitContainer.Panel1.ResumeLayout(false);
            this.splitContainer.Panel2.ResumeLayout(false);
            this.splitContainer.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox)).EndInit();
            this.goPanel.ResumeLayout(false);
            this.goPanel.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.threadsNumericUpDown)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();
            this.Shown += new EventHandler(MainForm_Shown);
            this.FormClosing += new FormClosingEventHandler(MainForm_FormClosing);

        }

        void MainForm_Shown( object sender, EventArgs e )
        {
            initialize();
        }

        void MainForm_FormClosing( object sender, FormClosingEventArgs e )
        {
            deinitialize();
        }

        void pictureBox_SizeChanged( object sender, EventArgs e )
        {
            refreshGraphics();
        }

        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.SetUnhandledExceptionMode( UnhandledExceptionMode.ThrowException );
            Application.Run( new MainForm() );
        }

        private struct TestItem
        {
            public int NumberOfThreads;
            public int PagesPerMinute;

            public TestItem( int numberOfThreads, int pagesPerMinute )
            {
                NumberOfThreads = numberOfThreads;
                PagesPerMinute = pagesPerMinute;
            }
        }

        private EnginesPool enginesPool;
        private ImageSource imageSource;
        private TestItem performanceResult;
        private WorkerThread[] workerThreads;
        private object traceLock;

        private int GetAllowedCoresNumber()
        {
            int cores = 0;
            // It's necessary to load FREngine instance to get information about license
            EngineLoader engineLoader = new Sample.EngineLoader();
            try {
                cores = engineLoader.Engine.CurrentLicense.AllowedCoresCount;
            } finally {
                if( engineLoader != null ) {
                    engineLoader.Dispose();
                    engineLoader = null;
                }
            }
            return cores;
        }

        private void initialize()
        {
            try {
                this.Cursor = Cursors.WaitCursor;
                textToolStrip.Text = "Initializing engines pool...";
                lockUI( true );

                // Configure the number of worker processes depending on the number of processors
                int availableCoresNumber = System.Environment.ProcessorCount;
                int allowedCoresNumber = GetAllowedCoresNumber();

                int optimalNumberOfThreads = 0;
                if( allowedCoresNumber == 0 ) {
                    // Zero value means for no limitation to the engines count
                    optimalNumberOfThreads = availableCoresNumber;
                } else {
                    optimalNumberOfThreads = Math.Min( allowedCoresNumber, availableCoresNumber );
                }

                threadsNumericUpDown.Value = optimalNumberOfThreads;
                threadsNumericUpDown.Minimum = 1;
                threadsNumericUpDown.Maximum = optimalNumberOfThreads;

                enginesPool = new EnginesPool( optimalNumberOfThreads, FreConfig.GetCustomerProjectId(), 60000 );
                enginesPool.AutoRecycleUsageCount = 100;

                performanceResult = new TestItem( optimalNumberOfThreads, 0 );
                workerThreads = null;
                traceLock = new object();
                refreshGraphics();
            } catch( Exception exception ) {
                MessageBox.Show( exception.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error );
                Application.Exit();
            } finally {
                lockUI( false );
                textToolStrip.Text = "Ready";
                this.Cursor = Cursors.Default;
            }
        }

        private void deinitialize()
        {
            try {
                this.Cursor = Cursors.WaitCursor;
                lockUI(true);

                if( workerThreads != null ) {
                    textToolStrip.Text = "Cancelling...";
                    cancelProcessing();
                }

                textToolStrip.Text = "Deinitializing engines pool...";

                if( enginesPool != null ) {
                    enginesPool.Dispose();
                    enginesPool = null;
                }
            } catch( Exception exception ) {
                MessageBox.Show( exception.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error );
                Application.Exit();
            }
        }

        private void lockUI( bool isLock )
        {
            goPanel.Enabled = !isLock;
            splitContainer.Panel1.Enabled = !isLock;
        }

        private void goButton_Click( object sender, EventArgs e )
        {
            if( goButton.Text == "Cancel" ) {
                throw new OperationCanceledException();
            }

            try {
                goButton.Text = "Cancel";

                string imagesFolder = Path.Combine( FreConfig.GetSamplesFolder(), "SampleImages\\MultiProcessingRecognition" );
                imageSource = new ImageSource( imagesFolder );

                runThreads( ( int )threadsNumericUpDown.Value, imageSource );
            } catch( Exception exception ) {
                MessageBox.Show( exception.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error );
            } finally {
                goButton.Text = "Go";
            }
        }

        private void runThreads( int numberOfThreads, ImageSource imageSource )
        {
            DateTime startTime = System.DateTime.Now;
            workerThreads = new WorkerThread [numberOfThreads];
            performanceResult.NumberOfThreads = numberOfThreads;
            performanceResult.PagesPerMinute = 0;
            refreshGraphics();
            resetTrace();

            try {
                textToolStrip.Text = "Running " + numberOfThreads.ToString() + " threads...";
                for( int i = 0; i < numberOfThreads; i++ ) {
                    workerThreads[i] = new WorkerThread( i, enginesPool, imageSource, trace );
                }

                bool isRunning = true;
                while( isRunning ) {
                    isRunning = false;
                    bool isProcessingFinishing = false;
                    foreach( var workerThread in workerThreads ) {
                        isRunning |= workerThread.IsRunning();
                        if( !workerThread.IsRunning() ) {
                            isProcessingFinishing = true;
                        }
                    }

                    if( !isProcessingFinishing && ( DateTime.Now - startTime ).TotalMinutes > 0.02 ) {
                        double processedImageFilesCount = imageSource.GetProcessedImageFilesCount();
                        double pagesPerMinute = processedImageFilesCount / ( DateTime.Now - startTime ).TotalMinutes;
                        performanceResult.PagesPerMinute = Convert.ToInt32( pagesPerMinute );
                        refreshGraphics();
                    }
                    Application.DoEvents();
                    Thread.Sleep( 500 );
                }
            } catch( OperationCanceledException ) {
                this.Cursor = Cursors.WaitCursor;
                textToolStrip.Text = "Cancelling...";
                lockUI( true );
                cancelProcessing();
                throw;
            } finally {
                workerThreads = null;
                lockUI( false );
                textToolStrip.Text = "Ready";
                this.Cursor = Cursors.Default;
            }
        }

        private void cancelProcessing()
        {
            foreach( var workerThread in workerThreads ) {
                workerThread.Cancel();
            }
            foreach( var workerThread in workerThreads ) {
                workerThread.Join();
            }
        }

        private void refreshGraphics()
        {
            if( pictureBox.Width > 0 && pictureBox.Height > 0 ) {
                BarData[] barData = new BarData [1];
                barData[0] = new BarData( performanceResult.NumberOfThreads.ToString(), performanceResult.PagesPerMinute, Color.Blue );
                Bitmap bitmap = new Bitmap( pictureBox.Width, pictureBox.Height );
                DrawingTools.DrawBarChart( bitmap, new Rectangle( 0, 0, pictureBox.Width, pictureBox.Height ), this.Font, barData, 
                    "Number of threads (" + System.Environment.ProcessorCount.ToString() + " CPU cores)", "Pages per minute", "" );

                pictureBox.Image = bitmap;
            }
        }

        private void trace( string message )
        {
            lock( traceLock ) {
                this.BeginInvoke( new MethodInvoker( delegate {
                    TreeNode node = traceTreeView.Nodes.Insert( traceTreeView.Nodes.Count - 1, message );
                    traceTreeView.SelectedNode = node;
                    node.EnsureVisible();
                } ) );
                Application.DoEvents();
            }
        }

        private void resetTrace()
        {
            lock( traceLock ) {
                traceTreeView.Nodes.Clear();
                traceTreeView.Nodes.Add( "" );
                Application.DoEvents();
            }
        }
    }
}
