//  2019 ABBYY Development Inc.
// SAMPLES code is property of ABBYY, exclusive rights are reserved. 
//
// DEVELOPER is allowed to incorporate SAMPLES into his own APPLICATION and modify it under 
// the  terms of  License Agreement between  ABBYY and DEVELOPER.


// ABBYY FineReader Engine 12 Sample

// This sample shows how to iterate throw recognized layout and calculate some
// char and word statistics

using System;
using System.Windows.Forms;
using System.IO;
using FREngine;

namespace Hello
{
    public class RecognizedTextProcessingForm : System.Windows.Forms.Form
    {
        private System.Windows.Forms.Button goButton;
        private System.Windows.Forms.StatusBar statusBar;
        private System.Windows.Forms.TextBox textBox1;
        private System.Windows.Forms.Button exit;
        private System.Windows.Forms.Label labelUnrecognizedSymbols;
        private System.Windows.Forms.Label labelAllSymbols;
        private System.Windows.Forms.Label labelAllWords;
        private System.Windows.Forms.Label labelNotDictionaryWords;
        private System.Windows.Forms.GroupBox groupBox1;
        private System.Windows.Forms.Label labelSuspiciosSymbols;

        //FineReader Engine loader object
        Sample.EngineLoader engineLoader = null;

        //Statistics counters 

        //Count of all suspicious symbols in layout
        private int suspiciousSymbolsCount;
        //Count of all unrecognized symbols in layout
        private int unrecognizedSymbolsCount;
        //Count of all nonspace symbols in layout
        private int allSymbolsCount;
        //Count of all words in layout
        private int allWordsCount;
        //Count of all not dictionary word in layout
        private int notDictionaryWordsCount;

        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

        public RecognizedTextProcessingForm()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if ( components != null ) 
                {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.goButton = new System.Windows.Forms.Button();
            this.statusBar = new System.Windows.Forms.StatusBar();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.exit = new System.Windows.Forms.Button();
            this.labelSuspiciosSymbols = new System.Windows.Forms.Label();
            this.labelUnrecognizedSymbols = new System.Windows.Forms.Label();
            this.labelAllSymbols = new System.Windows.Forms.Label();
            this.labelAllWords = new System.Windows.Forms.Label();
            this.labelNotDictionaryWords = new System.Windows.Forms.Label();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.groupBox1.SuspendLayout();
            this.SuspendLayout();
            // 
            // goButton
            // 
            this.goButton.Location = new System.Drawing.Point(193, 7);
            this.goButton.Name = "goButton";
            this.goButton.Size = new System.Drawing.Size(88, 28);
            this.goButton.TabIndex = 1;
            this.goButton.Text = "Go";
            this.goButton.Click += new System.EventHandler(this.goButton_Click);
            // 
            // statusBar
            // 
            this.statusBar.Location = new System.Drawing.Point(0, 223);
            this.statusBar.Name = "statusBar";
            this.statusBar.Size = new System.Drawing.Size(288, 22);
            this.statusBar.TabIndex = 8;
            // 
            // textBox1
            // 
            this.textBox1.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.textBox1.Location = new System.Drawing.Point(8, 8);
            this.textBox1.Multiline = true;
            this.textBox1.Name = "textBox1";
            this.textBox1.ReadOnly = true;
            this.textBox1.Size = new System.Drawing.Size(152, 56);
            this.textBox1.TabIndex = 9;
            this.textBox1.TabStop = false;
            this.textBox1.Text = "Click Go to\r\n 1. Open image file Demo.tif\r\n 2. Read it\r\n 3. Calculate statistics." +
                "";
            // 
            // exit
            // 
            this.exit.Location = new System.Drawing.Point(193, 42);
            this.exit.Name = "exit";
            this.exit.Size = new System.Drawing.Size(87, 27);
            this.exit.TabIndex = 10;
            this.exit.Text = "Exit";
            this.exit.Click += new System.EventHandler(this.exit_Click);
            // 
            // labelSuspiciosSymbols
            // 
            this.labelSuspiciosSymbols.Location = new System.Drawing.Point(8, 39);
            this.labelSuspiciosSymbols.Name = "labelSuspiciosSymbols";
            this.labelSuspiciosSymbols.Size = new System.Drawing.Size(256, 24);
            this.labelSuspiciosSymbols.TabIndex = 11;
            this.labelSuspiciosSymbols.Text = "Suspicious symbols:";
            // 
            // labelUnrecognizedSymbols
            // 
            this.labelUnrecognizedSymbols.Location = new System.Drawing.Point(8, 63);
            this.labelUnrecognizedSymbols.Name = "labelUnrecognizedSymbols";
            this.labelUnrecognizedSymbols.Size = new System.Drawing.Size(256, 24);
            this.labelUnrecognizedSymbols.TabIndex = 12;
            this.labelUnrecognizedSymbols.Text = "Unrecognized symbols";
            // 
            // labelAllSymbols
            // 
            this.labelAllSymbols.Location = new System.Drawing.Point(8, 16);
            this.labelAllSymbols.Name = "labelAllSymbols";
            this.labelAllSymbols.Size = new System.Drawing.Size(248, 23);
            this.labelAllSymbols.TabIndex = 1;
            this.labelAllSymbols.Text = "All symbols";
            // 
            // labelAllWords
            // 
            this.labelAllWords.Location = new System.Drawing.Point(8, 87);
            this.labelAllWords.Name = "labelAllWords";
            this.labelAllWords.Size = new System.Drawing.Size(240, 23);
            this.labelAllWords.TabIndex = 0;
            this.labelAllWords.Text = "All words";
            // 
            // labelNotDictionaryWords
            // 
            this.labelNotDictionaryWords.Location = new System.Drawing.Point(8, 110);
            this.labelNotDictionaryWords.Name = "labelNotDictionaryWords";
            this.labelNotDictionaryWords.Size = new System.Drawing.Size(256, 24);
            this.labelNotDictionaryWords.TabIndex = 15;
            this.labelNotDictionaryWords.Text = "Non-dictionary words";
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.labelAllWords);
            this.groupBox1.Controls.Add(this.labelAllSymbols);
            this.groupBox1.Controls.Add(this.labelNotDictionaryWords);
            this.groupBox1.Controls.Add(this.labelSuspiciosSymbols);
            this.groupBox1.Controls.Add(this.labelUnrecognizedSymbols);
            this.groupBox1.Location = new System.Drawing.Point(8, 80);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(272, 136);
            this.groupBox1.TabIndex = 16;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Results:";
            // 
            // RecognizedTextProcessingForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(288, 245);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.exit);
            this.Controls.Add(this.textBox1);
            this.Controls.Add(this.statusBar);
            this.Controls.Add(this.goButton);
            this.Name = "RecognizedTextProcessingForm";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "RecognizedTextProcessing";
            this.groupBox1.ResumeLayout(false);
            this.ResumeLayout(false);

        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main() 
        {    
            Application.Run( new RecognizedTextProcessingForm() );
        }

        private void displayMessage( string text )
        {
            statusBar.Text = text;
            this.Update();
        }        

        private void loadEngine()
        {
            if( engineLoader == null ) {
                engineLoader = new Sample.EngineLoader();
            }
        }

        private void loadProfile()
        {
            engineLoader.Engine.LoadPredefinedProfile("Default");
        }

        private void unloadEngine()
        {
            if( engineLoader != null ) {
                engineLoader.Dispose();
                engineLoader = null;
            }
        }

        private void setupFREngine()
        {
            displayMessage("Loading profile...");
            loadProfile();

            engineLoader.Engine.ParentWindow = this.Handle.ToInt64();
            engineLoader.Engine.ApplicationTitle = this.Text;
        }

        private void processImage()
        {
            // Create document
            FRDocument document = engineLoader.Engine.CreateFRDocument();

            try {
                // Add image file to document
                displayMessage( "Loading image..." );
                string imagePath = Path.Combine( FreConfig.GetSamplesFolder(), @"SampleImages\Demo.tif" );

                document.AddImageFile( imagePath, null, null );

                //Recognize document
                displayMessage( "Recognizing..." );
                document.Process( null );

                // Calculate text statistics
                displayMessage( "Calculating statistics..." );
                clearStatistics();
                for( int i = 0; i < document.Pages.Count; i++ ) {
                    calculateStatisticsForLayout( document.Pages[i].Layout );
                }

                //show calculated statistics
                displayStatistics();
                
            } catch( Exception error ) {
                MessageBox.Show( this, error.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error );
            }
            finally	{
                // Close document
                document.Close();
            }
        }

        private void processWithEngine()
        {
            try {
                // Setup FREngine
                setupFREngine();

                // Process sample image
                processImage();
            } catch( Exception error ) {
                MessageBox.Show( this, error.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error );
            }
        }

        private void goButton_Click( object sender, System.EventArgs e )
        {            
            try {
                // Load ABBYY FineReader Engine
                displayMessage( "Initializing Engine..." );
                loadEngine();

                // Process with ABBYY FineReader Engine
                processWithEngine();

                // Unload ABBYY FineReader Engine
                displayMessage( "Deinitializing Engine..." );
                unloadEngine();
            } catch( Exception error ) {
                MessageBox.Show( this, error.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error );
            }

            displayMessage( "" );
        }

        private void exit_Click( object sender, System.EventArgs e )
        {
            Close();
        }
        
        private void clearStatistics()
        {
            suspiciousSymbolsCount = unrecognizedSymbolsCount = allSymbolsCount = allWordsCount =
                notDictionaryWordsCount = 0;
        }

        private void calculateStatisticsForLayout( ILayout layout )
        {    
            ILayoutBlocks blocks = layout.Blocks;
            for( int index = 0; index < blocks.Count; index++ ) {
                calculateStatisticsForBlock( blocks[index] );
            }
        }

        void calculateStatisticsForBlock( IBlock block )
        {			
            if( block.Type == BlockTypeEnum.BT_Text ) {
                calculateStatisticsForTextBlock( block.GetAsTextBlock() );
            } else if( block.Type == BlockTypeEnum.BT_Table ) {
                calculateStatisticsForTableBlock( block.GetAsTableBlock() );
            }
        }

        void calculateStatisticsForTextBlock( ITextBlock textBlockProperties )
        {
            calculateStatisticsForText( textBlockProperties.Text );
        }

        void calculateStatisticsForTableBlock( ITableBlock tableBlockProperties )
        {
            for( int index = 0; index < tableBlockProperties.Cells.Count; index++ ) {
                calculateStatisticsForBlock( tableBlockProperties.Cells[index].Block );
            }
        }

        void calculateStatisticsForText( IText text ) 
        {
            IParagraphs paragraphs = text.Paragraphs;
            for( int index = 0; index < paragraphs.Count; index++ ) {
                calculateStatisticsForParagraph( paragraphs[index] );
            }
        }

        void calculateStatisticsForParagraph( IParagraph paragraph )
        {
            calculateCharStatisticsForParagraph( paragraph );

            calculateWordStatisticsForParagraph( paragraph );
        }

        void calculateCharStatisticsForParagraph( IParagraph paragraph )
        {
            for( int index = 0; index < paragraph.Text.Length; index++ )
            {
                calculateStatisticsForChar( paragraph, index );
            }
        }

        void calculateStatisticsForChar( IParagraph paragraph, int charIndex )
        {
            ICharParams charParams = engineLoader.Engine.CreateCharParams();
            paragraph.GetCharParams( charIndex, charParams );
            if( charParams.IsSuspicious ) 
            {
                suspiciousSymbolsCount++;
            }

            if( isUnrecognizedSymbol( paragraph.Text[charIndex] ) ) 
            {
                unrecognizedSymbolsCount++;
            }

            if( paragraph.Text[charIndex] != ' ' ) 
            {
                allSymbolsCount++;
            }
        }

        void calculateWordStatisticsForParagraph( IParagraph paragraph )
        {
            allWordsCount += paragraph.Words.Count;

            for( int index = 0; index < paragraph.Words.Count; index++ ) 
            {
                if( !paragraph.Words[index].IsWordFromDictionary ) 
                {
                    notDictionaryWordsCount ++;
                }
            }
        }

        bool isUnrecognizedSymbol( char symbol )
        {
            //it is special constant used by FREngine recogniser
            return ( symbol == 0x005E );
        }

        void displayStatistics()
        {
            labelAllSymbols.Text = "All symbols: " + allSymbolsCount.ToString();
            labelSuspiciosSymbols.Text = "Suspicious symbols: " + suspiciousSymbolsCount.ToString();
            labelUnrecognizedSymbols.Text = "Unrecognized symbols: " + unrecognizedSymbolsCount.ToString();

            labelAllWords.Text = "All words: " + allWordsCount.ToString();
            labelNotDictionaryWords.Text = "Non-dictionary words: " + notDictionaryWordsCount.ToString();
        }
    }
}
