//  2019 ABBYY Development Inc.
// SAMPLES code is property of ABBYY, exclusive rights are reserved. 
//
// DEVELOPER is allowed to incorporate SAMPLES into his own APPLICATION and modify it under 
// the  terms of  License Agreement between  ABBYY and DEVELOPER.


// ABBYY FineReader Engine 12 Sample

// This sample shows basic steps of ABBYY FineReader Engine usage:
// Initializing, opening image file, recognition and export, deinitializing

using System;
using System.Windows.Forms;
using System.IO;

namespace Scanning
{
	public class ScanningForm : System.Windows.Forms.Form
	{
		Sample.EngineLoader engineLoader = null;
		private System.Windows.Forms.Button goButton;
		private System.Windows.Forms.StatusBar statusBar;
		private Label label1;
		private ComboBox sourcesCombo;
		private Label label2;
		private TextBox txtScanFolder;
		private Button btnBrowse;
		private FREngine.IScanManager scanManager;
		private FolderBrowserDialog folderBrowserDlg;
		private Label label3;
		private ComboBox uiCombo;
		private Label label4;
		private ComboBox apiCombo;
		private Label label5;
		private bool isInitialized = false;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ScanningForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		public void CompleteScan()
		{
			// Enable Scan button
			goButton.Enabled = true;
			displayMessage("Scanning completed.");
		}

		public void ReportError(string errDescription)
		{
			displayMessage(errDescription);
		}

		public void OnImageScanned(string fileName)
		{
			string msg = String.Format("Scanned image: {0}", fileName);
			displayMessage(msg);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.goButton = new System.Windows.Forms.Button();
			this.statusBar = new System.Windows.Forms.StatusBar();
			this.label1 = new System.Windows.Forms.Label();
			this.sourcesCombo = new System.Windows.Forms.ComboBox();
			this.label2 = new System.Windows.Forms.Label();
			this.txtScanFolder = new System.Windows.Forms.TextBox();
			this.btnBrowse = new System.Windows.Forms.Button();
			this.folderBrowserDlg = new System.Windows.Forms.FolderBrowserDialog();
			this.label3 = new System.Windows.Forms.Label();
			this.uiCombo = new System.Windows.Forms.ComboBox();
			this.label4 = new System.Windows.Forms.Label();
			this.apiCombo = new System.Windows.Forms.ComboBox();
			this.label5 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// goButton
			// 
			this.goButton.Location = new System.Drawing.Point(286, 235);
			this.goButton.Name = "goButton";
			this.goButton.Size = new System.Drawing.Size(88, 28);
			this.goButton.TabIndex = 8;
			this.goButton.Text = "Scan";
			this.goButton.Click += new System.EventHandler(this.goButton_Click);
			// 
			// statusBar
			// 
			this.statusBar.Location = new System.Drawing.Point(0, 280);
			this.statusBar.Name = "statusBar";
			this.statusBar.Size = new System.Drawing.Size(382, 22);
			this.statusBar.TabIndex = 9;
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(14, 126);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(110, 13);
			this.label1.TabIndex = 0;
			this.label1.Text = "Select a scan source:";
			// 
			// sourcesCombo
			// 
			this.sourcesCombo.FormattingEnabled = true;
			this.sourcesCombo.Location = new System.Drawing.Point(17, 145);
			this.sourcesCombo.Name = "sourcesCombo";
			this.sourcesCombo.Size = new System.Drawing.Size(356, 21);
			this.sourcesCombo.TabIndex = 1;
			// 
			// label2
			// 
			this.label2.AutoSize = true;
			this.label2.Location = new System.Drawing.Point(14, 177);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(210, 13);
			this.label2.TabIndex = 4;
			this.label2.Text = "Specify the folder to store scanned images:";
			// 
			// txtScanFolder
			// 
			this.txtScanFolder.Location = new System.Drawing.Point(19, 199);
			this.txtScanFolder.Name = "txtScanFolder";
			this.txtScanFolder.Size = new System.Drawing.Size(261, 20);
			this.txtScanFolder.TabIndex = 5;
			// 
			// btnBrowse
			// 
			this.btnBrowse.Location = new System.Drawing.Point(286, 195);
			this.btnBrowse.Name = "btnBrowse";
			this.btnBrowse.Size = new System.Drawing.Size(88, 28);
			this.btnBrowse.TabIndex = 6;
			this.btnBrowse.Text = "Browse";
			this.btnBrowse.Click += new System.EventHandler(this.btnBrowse_Click);
			// 
			// label3
			// 
			this.label3.AutoSize = true;
			this.label3.Location = new System.Drawing.Point(14, 76);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(250, 13);
			this.label3.TabIndex = 2;
			this.label3.Text = "Select the way how you want to tune scan settings:";
			// 
			// uiCombo
			// 
			this.uiCombo.FormattingEnabled = true;
			this.uiCombo.Location = new System.Drawing.Point(17, 95);
			this.uiCombo.Name = "uiCombo";
			this.uiCombo.Size = new System.Drawing.Size(356, 21);
			this.uiCombo.TabIndex = 3;
			this.uiCombo.SelectedIndexChanged += new System.EventHandler(this.uiCombo_SelectedIndexChanged);
			// 
			// label4
			// 
			this.label4.AutoSize = true;
			this.label4.Location = new System.Drawing.Point(14, 243);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(224, 13);
			this.label4.TabIndex = 7;
			this.label4.Text = "Click Scan to scan images into selected folder";
			// 
			// apiCombo
			// 
			this.apiCombo.FormattingEnabled = true;
			this.apiCombo.Location = new System.Drawing.Point(17, 40);
			this.apiCombo.Name = "apiCombo";
			this.apiCombo.Size = new System.Drawing.Size(356, 21);
			this.apiCombo.TabIndex = 11;
			this.apiCombo.SelectedIndexChanged += new System.EventHandler(this.apiCombo_SelectedIndexChanged);
			// 
			// label5
			// 
			this.label5.AutoSize = true;
			this.label5.Location = new System.Drawing.Point(14, 21);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(147, 13);
			this.label5.TabIndex = 10;
			this.label5.Text = "Select scan source  API type:";
			// 
			// ScanningForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(382, 302);
			this.Controls.Add(this.apiCombo);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.uiCombo);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.btnBrowse);
			this.Controls.Add(this.txtScanFolder);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.sourcesCombo);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.statusBar);
			this.Controls.Add(this.goButton);
			this.Name = "ScanningForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Scanning";
			this.Load += new System.EventHandler(this.ScanningForm_Load);
			this.FormClosed += new System.Windows.Forms.FormClosedEventHandler(this.ScanningForm_FormClosed);
			this.ResumeLayout(false);
			this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.Run(new ScanningForm());
		}

		private void displayMessage(string text)
		{
			statusBar.Text = text;
			this.Update();
		}

		private void loadEngine()
		{
			if (engineLoader == null)
			{
				engineLoader = new Sample.EngineLoader();
			}
		}

		private void setupFREngine()
		{
			displayMessage("Loading predefined profile...");
			loadProfile();

			engineLoader.Engine.ParentWindow = this.Handle.ToInt64();
			engineLoader.Engine.ApplicationTitle = this.Text;
		}

		private void loadProfile()
		{
			engineLoader.Engine.LoadPredefinedProfile("Default");
		}

		private void unloadEngine()
		{
			if (engineLoader != null)
			{
				engineLoader.Dispose();
				engineLoader = null;
			}
		}

		private void loadScanningSources()
		{
			displayMessage("Loading scanning source...");
			scanManager = engineLoader.Engine.CreateScanManager(false);
			// Fill scan sources combo
			fillScanSourcesCombo();
			sourcesCombo.DisplayMember = "Name";
		}

		private void fillScanSourcesCombo()
		{
			sourcesCombo.Items.Clear();
			sourcesCombo.ResetText();
			FREngine.IScanSources sources = scanManager.FindScanSources(((ScanUITypeItem)uiCombo.SelectedItem).UIType,
				((ScanAPITypeItem)apiCombo.SelectedItem).APIType);
			foreach (FREngine.IScanSource source in sources)
			{
				sourcesCombo.Items.Add(source);
			}
			if (sourcesCombo.Items.Count > 0)
			{
				sourcesCombo.SelectedIndex = 0;
			}
			goButton.Enabled = (sourcesCombo.Items.Count > 0);
		}

		private void fillUICombo()
		{
			uiCombo.Items.Clear();
			uiCombo.Items.Add(new ScanUITypeItem(FREngine.ScanSourceUITypeEnum.SSUIT_None, "Use default settings (no dialog box will be displayed)"));
			uiCombo.Items.Add(new ScanUITypeItem(FREngine.ScanSourceUITypeEnum.SSUIT_Fine, "Tune settings in ABBYY dialog box"));
			uiCombo.Items.Add(new ScanUITypeItem(FREngine.ScanSourceUITypeEnum.SSUIT_Scanner, "Tune settings in scanner dialog box"));
			uiCombo.SelectedIndex = 0;
			uiCombo.DisplayMember = "Description";
		}

		private void fillApiCombo()
		{
			apiCombo.Items.Clear();
			apiCombo.Items.Add( new ScanAPITypeItem(FREngine.ScanSourceApiTypeEnum.SSAT_All, "All"));
			apiCombo.Items.Add( new ScanAPITypeItem(FREngine.ScanSourceApiTypeEnum.SSAT_Twain, "Twain"));
			apiCombo.Items.Add( new ScanAPITypeItem(FREngine.ScanSourceApiTypeEnum.SSAT_Wia, "Wia"));
			apiCombo.SelectedIndex = 0;
			apiCombo.DisplayMember = "Description";
		}

		private bool init()
		{
			try
			{
				// Load ABBYY FineReader Engine
				loadEngine();

				// Setup FREngine
				setupFREngine();

				// Fill api types combo
				fillApiCombo();

				// Fill user interface types combo
				fillUICombo();

				// Load scanning sources
				loadScanningSources();

				isInitialized = true;
			}
			catch (Exception error)
			{
				MessageBox.Show(this, error.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
				return false;
			}
			displayMessage("");
			return true;
		}

		private void scan()
		{

			try
			{
				FREngine.IScanSource selectedSource = (FREngine.IScanSource) sourcesCombo.SelectedItem;

				string scanFolder = txtScanFolder.Text.Trim();

				if( scanFolder.Length == 0 ) {
					MessageBox.Show( "Please, select the scan folder.", this.Text, 
						MessageBoxButtons.OK, MessageBoxIcon.Exclamation );
					return;
				}
				if( !System.IO.Directory.Exists( scanFolder ) )
				{
					MessageBox.Show("Folder \"" + scanFolder + "\" does not exist.", this.Text,
						MessageBoxButtons.OK, MessageBoxIcon.Error);
					return;
				}

				FREngine.ScanSourceSettings settings = selectedSource.ScanSettings;
				FREngine.IScanSourceCapabilities capabilities = selectedSource.Capabilities;
				settings.DuplexMode = capabilities.HasDuplexMode;
				settings.MultipleImagesEnabled = true;
				settings.PauseBetweenPagesMode = FREngine.ScanPauseModeEnum.SPM_PresetDelay;
				settings.Delay = 10;

				ScanningCallback callback = new ScanningCallback(this);
				displayMessage("Start scanning...");
				selectedSource.BeginScan(((ScanUITypeItem)uiCombo.SelectedItem).UIType, scanFolder, callback);

				// Disable Scan button
				goButton.Enabled = false;
			}
			catch (Exception error)
			{
				MessageBox.Show(this, error.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void goButton_Click(object sender, System.EventArgs e)
		{
			try
			{
				// Scan images
				scan();
			}
			catch (Exception error)
			{
				MessageBox.Show(this, error.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void btnBrowse_Click(object sender, EventArgs e)
		{
			folderBrowserDlg.Description = "Select the folder for scanned images:";
			folderBrowserDlg.SelectedPath = txtScanFolder.Text.Trim();
			if (folderBrowserDlg.ShowDialog() == DialogResult.OK)
			{
				txtScanFolder.Text = folderBrowserDlg.SelectedPath;
			}
		}

		private void ScanningForm_Load(object sender, EventArgs e)
		{
			// Initialize target folder for scanned images
			txtScanFolder.Text = Path.Combine( FreConfig.GetSamplesFolder(), "SampleImages");

			// Disable Scan button
			goButton.Enabled = false;

			// Create application exit event handler
			System.Windows.Forms.Application.ApplicationExit += new EventHandler(application_onExit);

			// Load FREngine and initialize Scan manager and Scan sources list
			if( !init() ) {
				System.Windows.Forms.Application.Exit();
			}
		}

		private void ScanningForm_FormClosed(object sender, FormClosedEventArgs e)
		{
			try
			{
				sourcesCombo.Items.Clear();
				scanManager = null;
			}
			catch (Exception error)
			{
				MessageBox.Show(this, error.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void application_onExit(Object sender, EventArgs e)
		{
			try
			{
				// Unload ABBYY FineReader Engine
				unloadEngine();
			}
			catch (Exception error)
			{
				MessageBox.Show(this, error.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void apiCombo_SelectedIndexChanged(object sender, EventArgs e)
		{
			if (apiCombo.SelectedIndex != -1 && isInitialized)
			{
				// Fill scan sources combo
				fillScanSourcesCombo();
			}
		}

		private void uiCombo_SelectedIndexChanged(object sender, EventArgs e)
		{
			if (uiCombo.SelectedIndex != -1 && isInitialized)
			{
				// Fill scan sources combo
				fillScanSourcesCombo();
			}
		}
	}

	public class ScanUITypeItem
	{
		private FREngine.ScanSourceUITypeEnum scanUIType;
		private string scanUIDescription;

		public ScanUITypeItem(FREngine.ScanSourceUITypeEnum uiType, string uiDescription)
		{
			scanUIType = uiType;
			scanUIDescription = uiDescription;
		}

		public FREngine.ScanSourceUITypeEnum UIType
		{
			get
			{
				return scanUIType;
			}
		}

		public string Description
		{
			get
			{
				return scanUIDescription;
			}
		}
	}

	public class ScanAPITypeItem
	{
		private FREngine.ScanSourceApiTypeEnum scapApiType;
		private string scanApiDescription;

		public ScanAPITypeItem(FREngine.ScanSourceApiTypeEnum apiType, string apiDescription)
		{
			scapApiType = apiType;
			scanApiDescription = apiDescription;
		}

		public FREngine.ScanSourceApiTypeEnum APIType
		{
			get
			{
				return scapApiType;
			}
		}

		public string Description
		{
			get 
			{
				return scanApiDescription;
			}
		}
	}
}
