//  2019 ABBYY Development Inc.
// SAMPLES code is property of ABBYY, exclusive rights are reserved. 
//
// DEVELOPER is allowed to incorporate SAMPLES into his own APPLICATION and modify it under 
// the  terms of  License Agreement between  ABBYY and DEVELOPER.


// ABBYY FineReader Engine 12 Sample

// This sample illustrates basic usage of FineReader Engine Visual Components

using System;
using System.Windows.Forms;

namespace VisualComponents
{
    /// <summary>
    /// Summary description for VisualComponentsForm.
    /// </summary>
    public class VisualComponentsForm : System.Windows.Forms.Form
    {
        //Global Engine loader and Synchronizer objects
        public static Sample.EngineLoader engineLoader = null;
        public static FineReaderVisualComponents.ComponentSynchronizer Synchronizer = null;
        
        public FREngine.FRDocument Document = null;
        private FREngine.DIFRDocumentEvents_OnPageProcessedEventHandler pageProcessedHandler = null;
        private FineReaderVisualComponents.DIImageViewerEvents_OnProgressEventHandler imageViewerProgressEventHandler = null;
        private FineReaderVisualComponents.DIDocumentViewerEvents_OnProgressEventHandler documentViewerProgressEventHandler = null;
        private static ValidatorForm validatorForm = null;

        private System.Windows.Forms.Button openButton;
        private System.Windows.Forms.Button recognizeButton;
        private System.Windows.Forms.Button validateButton;
        private System.Windows.Forms.Button exportButton;
        private System.Windows.Forms.Button closeButton;
        private System.Windows.Forms.OpenFileDialog openFileDialog;
        private System.Windows.Forms.SaveFileDialog saveFileDialog;
        private AxFineReaderVisualComponents.AxZoomViewer zoomViewer;
        private AxFineReaderVisualComponents.AxDocumentViewer documentViewer;
        private AxFineReaderVisualComponents.AxImageViewer imageViewer;
        private AxFineReaderVisualComponents.AxTextEditor textEditor;
        
        private bool doCancel = false;
		private bool isTextButtonsEnabled = false;
        private Panel panel1;
        private SplitContainer splitContainer1;
        private SplitContainer splitContainer2;
        private SplitContainer splitContainer3;
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

        public VisualComponentsForm()
        {
            // Required for Windows Form Designer support
            InitializeComponent();
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if (components != null) 
                {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(VisualComponentsForm));
			this.openButton = new System.Windows.Forms.Button();
			this.validateButton = new System.Windows.Forms.Button();
			this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.exportButton = new System.Windows.Forms.Button();
			this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
			this.closeButton = new System.Windows.Forms.Button();
			this.recognizeButton = new System.Windows.Forms.Button();
			this.zoomViewer = new AxFineReaderVisualComponents.AxZoomViewer();
			this.documentViewer = new AxFineReaderVisualComponents.AxDocumentViewer();
			this.imageViewer = new AxFineReaderVisualComponents.AxImageViewer();
			this.textEditor = new AxFineReaderVisualComponents.AxTextEditor();
			this.panel1 = new System.Windows.Forms.Panel();
			this.splitContainer1 = new System.Windows.Forms.SplitContainer();
			this.splitContainer2 = new System.Windows.Forms.SplitContainer();
			this.splitContainer3 = new System.Windows.Forms.SplitContainer();
			((System.ComponentModel.ISupportInitialize)(this.zoomViewer)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.documentViewer)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.imageViewer)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.textEditor)).BeginInit();
			this.panel1.SuspendLayout();
			this.splitContainer1.Panel1.SuspendLayout();
			this.splitContainer1.Panel2.SuspendLayout();
			this.splitContainer1.SuspendLayout();
			this.splitContainer2.Panel1.SuspendLayout();
			this.splitContainer2.Panel2.SuspendLayout();
			this.splitContainer2.SuspendLayout();
			this.splitContainer3.Panel1.SuspendLayout();
			this.splitContainer3.Panel2.SuspendLayout();
			this.splitContainer3.SuspendLayout();
			this.SuspendLayout();
			// 
			// openButton
			// 
			this.openButton.Location = new System.Drawing.Point(10, 10);
			this.openButton.Name = "openButton";
			this.openButton.Size = new System.Drawing.Size(93, 32);
			this.openButton.TabIndex = 4;
			this.openButton.Text = "Open";
			this.openButton.Click += new System.EventHandler(this.openButton_Click);
			// 
			// validateButton
			// 
			this.validateButton.Enabled = false;
			this.validateButton.Location = new System.Drawing.Point(207, 10);
			this.validateButton.Name = "validateButton";
			this.validateButton.Size = new System.Drawing.Size(93, 32);
			this.validateButton.TabIndex = 5;
			this.validateButton.Text = "Validate";
			this.validateButton.Click += new System.EventHandler(this.validateButton_Click);
			// 
			// exportButton
			// 
			this.exportButton.Enabled = false;
			this.exportButton.Location = new System.Drawing.Point(305, 10);
			this.exportButton.Name = "exportButton";
			this.exportButton.Size = new System.Drawing.Size(93, 32);
			this.exportButton.TabIndex = 6;
			this.exportButton.Text = "Export";
			this.exportButton.Click += new System.EventHandler(this.exportButton_Click);
			// 
			// closeButton
			// 
			this.closeButton.Location = new System.Drawing.Point(403, 10);
			this.closeButton.Name = "closeButton";
			this.closeButton.Size = new System.Drawing.Size(94, 32);
			this.closeButton.TabIndex = 8;
			this.closeButton.Text = "Close";
			this.closeButton.Click += new System.EventHandler(this.closeButton_Click);
			// 
			// recognizeButton
			// 
			this.recognizeButton.Enabled = false;
			this.recognizeButton.Location = new System.Drawing.Point(108, 10);
			this.recognizeButton.Name = "recognizeButton";
			this.recognizeButton.Size = new System.Drawing.Size(94, 32);
			this.recognizeButton.TabIndex = 12;
			this.recognizeButton.Text = "Recognize";
			this.recognizeButton.Click += new System.EventHandler(this.recognizeButton_Click);
			// 
			// zoomViewer
			// 
			this.zoomViewer.Dock = System.Windows.Forms.DockStyle.Fill;
			this.zoomViewer.Enabled = true;
			this.zoomViewer.Location = new System.Drawing.Point(0, 0);
			this.zoomViewer.Name = "zoomViewer";
			this.zoomViewer.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("zoomViewer.OcxState")));
			this.zoomViewer.Size = new System.Drawing.Size(1026, 174);
			this.zoomViewer.TabIndex = 13;
			this.zoomViewer.OnLongOperationStarted += new System.EventHandler(this.OnLongOperationStarted);
			this.zoomViewer.OnLongOperationFinished += new System.EventHandler(this.OnLongOperationFinished);
			// 
			// documentViewer
			// 
			this.documentViewer.Dock = System.Windows.Forms.DockStyle.Fill;
			this.documentViewer.Enabled = true;
			this.documentViewer.Location = new System.Drawing.Point(0, 0);
			this.documentViewer.Name = "documentViewer";
			this.documentViewer.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("documentViewer.OcxState")));
			this.documentViewer.Size = new System.Drawing.Size(193, 672);
			this.documentViewer.TabIndex = 14;
			this.documentViewer.OnLongOperationFinished += new System.EventHandler(this.OnLongOperationFinished);
			this.documentViewer.OnLongOperationStarted += new System.EventHandler(this.OnLongOperationStarted);
			// 
			// imageViewer
			// 
			this.imageViewer.Dock = System.Windows.Forms.DockStyle.Fill;
			this.imageViewer.Enabled = true;
			this.imageViewer.Location = new System.Drawing.Point(0, 0);
			this.imageViewer.Name = "imageViewer";
			this.imageViewer.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("imageViewer.OcxState")));
			this.imageViewer.Size = new System.Drawing.Size(477, 494);
			this.imageViewer.TabIndex = 15;
			this.imageViewer.OnLongOperationStarted += new System.EventHandler(this.OnLongOperationStarted);
			this.imageViewer.OnLongOperationFinished += new System.EventHandler(this.OnLongOperationFinished);
			// 
			// textEditor
			// 
			this.textEditor.Dock = System.Windows.Forms.DockStyle.Fill;
			this.textEditor.Enabled = true;
			this.textEditor.Location = new System.Drawing.Point(0, 0);
			this.textEditor.Name = "textEditor";
			this.textEditor.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("textEditor.OcxState")));
			this.textEditor.Size = new System.Drawing.Size(545, 494);
			this.textEditor.TabIndex = 16;
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.closeButton);
			this.panel1.Controls.Add(this.openButton);
			this.panel1.Controls.Add(this.exportButton);
			this.panel1.Controls.Add(this.recognizeButton);
			this.panel1.Controls.Add(this.validateButton);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(1223, 55);
			this.panel1.TabIndex = 17;
			// 
			// splitContainer1
			// 
			this.splitContainer1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.splitContainer1.Location = new System.Drawing.Point(0, 55);
			this.splitContainer1.Name = "splitContainer1";
			// 
			// splitContainer1.Panel1
			// 
			this.splitContainer1.Panel1.Controls.Add(this.documentViewer);
			// 
			// splitContainer1.Panel2
			// 
			this.splitContainer1.Panel2.Controls.Add(this.splitContainer2);
			this.splitContainer1.Size = new System.Drawing.Size(1223, 672);
			this.splitContainer1.SplitterDistance = 193;
			this.splitContainer1.TabIndex = 18;
			// 
			// splitContainer2
			// 
			this.splitContainer2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.splitContainer2.Location = new System.Drawing.Point(0, 0);
			this.splitContainer2.Name = "splitContainer2";
			this.splitContainer2.Orientation = System.Windows.Forms.Orientation.Horizontal;
			// 
			// splitContainer2.Panel1
			// 
			this.splitContainer2.Panel1.Controls.Add(this.splitContainer3);
			// 
			// splitContainer2.Panel2
			// 
			this.splitContainer2.Panel2.Controls.Add(this.zoomViewer);
			this.splitContainer2.Size = new System.Drawing.Size(1026, 672);
			this.splitContainer2.SplitterDistance = 494;
			this.splitContainer2.TabIndex = 14;
			// 
			// splitContainer3
			// 
			this.splitContainer3.Dock = System.Windows.Forms.DockStyle.Fill;
			this.splitContainer3.Location = new System.Drawing.Point(0, 0);
			this.splitContainer3.Name = "splitContainer3";
			// 
			// splitContainer3.Panel1
			// 
			this.splitContainer3.Panel1.Controls.Add(this.imageViewer);
			// 
			// splitContainer3.Panel2
			// 
			this.splitContainer3.Panel2.Controls.Add(this.textEditor);
			this.splitContainer3.Size = new System.Drawing.Size(1026, 494);
			this.splitContainer3.SplitterDistance = 477;
			this.splitContainer3.TabIndex = 17;
			// 
			// VisualComponentsForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(1223, 727);
			this.Controls.Add(this.splitContainer1);
			this.Controls.Add(this.panel1);
			this.Name = "VisualComponentsForm";
			this.Text = "Visual Components Demo";
			this.Load += new System.EventHandler(this.VisualComponentsForm_Load);
			this.Closed += new System.EventHandler(this.VisualComponentsForm_Closed);
			((System.ComponentModel.ISupportInitialize)(this.zoomViewer)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.documentViewer)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.imageViewer)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.textEditor)).EndInit();
			this.panel1.ResumeLayout(false);
			this.splitContainer1.Panel1.ResumeLayout(false);
			this.splitContainer1.Panel2.ResumeLayout(false);
			this.splitContainer1.ResumeLayout(false);
			this.splitContainer2.Panel1.ResumeLayout(false);
			this.splitContainer2.Panel2.ResumeLayout(false);
			this.splitContainer2.ResumeLayout(false);
			this.splitContainer3.Panel1.ResumeLayout(false);
			this.splitContainer3.Panel2.ResumeLayout(false);
			this.splitContainer3.ResumeLayout(false);
			this.ResumeLayout(false);

        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main() 
        {    
            Application.Run(new VisualComponentsForm());
        }

        // The path to the FREngine.dll should be adjusted for other apps.

        private void VisualComponentsForm_Load(object sender, System.EventArgs e)
        {
            // Attach components to Synchronizer
            Synchronizer = new FineReaderVisualComponents.ComponentSynchronizerClass();
            Synchronizer.DocumentViewer = ( FineReaderVisualComponents.DocumentViewer ) documentViewer.GetOcx();
            Synchronizer.ImageViewer = ( FineReaderVisualComponents.ImageViewer ) imageViewer.GetOcx();
            Synchronizer.ZoomViewer = ( FineReaderVisualComponents.ZoomViewer ) zoomViewer.GetOcx();
            Synchronizer.TextEditor = ( FineReaderVisualComponents.TextEditor ) textEditor.GetOcx();

            // Add events handlers
            imageViewerProgressEventHandler = new FineReaderVisualComponents.DIImageViewerEvents_OnProgressEventHandler( viewers_onProgress );
            Synchronizer.ImageViewer.OnProgress += imageViewerProgressEventHandler;

            documentViewerProgressEventHandler = new FineReaderVisualComponents.DIDocumentViewerEvents_OnProgressEventHandler( viewers_onProgress );
            Synchronizer.DocumentViewer.OnProgress += documentViewerProgressEventHandler;
            System.Windows.Forms.Application.ApplicationExit += new EventHandler( application_onExit );
        }

        private void loadEngine()
        {
            if( engineLoader == null ) 
            {
                engineLoader = new Sample.EngineLoader();
            }
        }

        private void loadProfile()
        {
            engineLoader.Engine.LoadPredefinedProfile("Default");
        }

        private void unloadEngine()
        {
            if( engineLoader != null ) 
            {
                engineLoader.Dispose();
                engineLoader = null;
            }
        }

        private void openImage( string[] fileNames )
        {
            try 
            {
                // Load ABBYY FineReader Engine
                if( engineLoader == null ) 
                {
                    loadEngine();
                    loadProfile();
                    engineLoader.Engine.ParentWindow = this.Handle.ToInt64();
                    engineLoader.Engine.ApplicationTitle = this.Text;
                }
                if( Document == null)
                {
                    // Create empty document
                    Document = engineLoader.Engine.CreateFRDocument();
                    pageProcessedHandler = new FREngine.DIFRDocumentEvents_OnPageProcessedEventHandler( document_pageProcessedHandler );
                    Document.OnPageProcessed += pageProcessedHandler;
                    // Attach image to Visual Components using Synchronizer
                    Synchronizer.Document = Document;
                    // Create processing params
                    Synchronizer.ProcessingParams = engineLoader.Engine.CreateDocumentProcessingParams();
                }

                // Open image
                for( int i = 0; i < fileNames.Length; i++ ) 
                {
                    Document.AddImageFile( fileNames[i], null,  null );
                }
            }
            catch (Exception error)
            {
                showError(error);
            }
        }

        private void openButton_Click(object sender, System.EventArgs e)
        {
            try 
            {
                openFileDialog.InitialDirectory = FreConfig.GetSamplesFolder() + "\\SampleImages";
                openFileDialog.Multiselect = true;
                DialogResult result = openFileDialog.ShowDialog();
                if( result == DialogResult.OK ) 
                {
                    doCancel = false;
                    enableCommandsAndBasicButtons( false );
                    openImage( openFileDialog.FileNames );
                    enableCommandsAndBasicButtons( true );
                    if (Synchronizer.Document != null && Synchronizer.Document.Pages.Count > 0)
                    {
                        Synchronizer.PageIndex = 0;
                    }
                }
            } 
            catch( Exception error ) 
            {
                showError(error);
            }
        }

        private void recognizeButton_Click(object sender, System.EventArgs e)
        {
            enableCommandsAndBasicButtons( false );
            enableButtonsForTextEditor(false);
            try 
            {
                // recognize and synthetise the whole document
                FREngine.DocumentProcessingParams processingParams = Synchronizer.ProcessingParams;

                FREngine.DIFRDocumentEvents_OnProgressEventHandler progressHandler = 
                    new FREngine.DIFRDocumentEvents_OnProgressEventHandler(
                    document_OnProgress );
                Document.OnProgress += progressHandler;

                Document.Process( processingParams );

                Document.OnProgress -= progressHandler;
            }
            catch( Exception error ) 
            {
                showError(error);
            }
            enableCommandsAndBasicButtons( true );
        }

        private void validateButton_Click(object sender, System.EventArgs e)
        {
            try 
            {
                if( validatorForm == null ) 
                {
                    // Create new form for validation
                    validatorForm = new ValidatorForm();
                    validatorForm.Owner = this;
                
                    // Attach validator to Synchronizer
                    Synchronizer.TextValidator = ( FineReaderVisualComponents.TextValidator ) validatorForm.TextValidator.GetOcx();
                    validatorForm.Show();

                    // Validate the whole Layout of current attached page
                    validatorForm.TextValidator.Spell( null );
                }
            }
            catch( Exception error ) 
            {
                showError(error);
            }
        }

        public static void DetachValidatorForm()
        {
            // Detach validator from Synchronizer
            Synchronizer.TextValidator = null;
            
            validatorForm = null;
        }

        private void exportButton_Click(object sender, System.EventArgs e)
        {
            enableCommandsAndBasicButtons( false );
            enableButtonsForTextEditor( false );
            try 
            {
                // Export document to RTF
                saveFileDialog.Filter = "RTF files (*.rtf)|*.rtf|All Files (*.*)|*.*";
                DialogResult result = saveFileDialog.ShowDialog();
                if( result == DialogResult.OK ) 
                {
                    // synthesize if page or document structure is invalid
                    synthesizeIfNeed();
                    Document.Export( saveFileDialog.FileName, FREngine.FileExportFormatEnum.FEF_RTF, null );
                } 
            }
            catch( Exception error ) 
            {
                showError(error);
            }
            enableCommandsAndBasicButtons( true );
            enableButtonsForTextEditor( true );
        }

        private void synthesizeIfNeed()
        {
            try 
            {
                FREngine.IIntsCollection pageIndices = engineLoader.Engine.CreateIntsCollection();
                for( int i = 0; i < Document.Pages.Count; i++ ) 
                {
                    if( Document.Pages[i].PageStructureOutOfDate ) 
                    {
                        pageIndices.Add( i );
                    }
                }
                if( pageIndices.Count > 0 || Document.DocumentStructureOutOfDate ) 
                {
                    Document.SynthesizePages( pageIndices, Synchronizer.ProcessingParams.SynthesisParamsForDocument );
                }
            }
            catch( Exception error ) 
            {
                showError(error);
            }
        }

        private void VisualComponentsForm_Closed(object sender, System.EventArgs e)
        {
            doCancel = true;
            try 
            {
                Synchronizer.ImageViewer.OnProgress -= imageViewerProgressEventHandler;
                imageViewerProgressEventHandler = null;
                Synchronizer.DocumentViewer.OnProgress -= documentViewerProgressEventHandler;
                documentViewerProgressEventHandler = null;
                // Detach document and images from Visual Components
                if( Document != null ) 
                {
                    Document.OnPageProcessed -= pageProcessedHandler;
                    pageProcessedHandler = null;
                    Document = null;
                }
                Synchronizer = null;
            }
            catch( Exception error ) 
            {
                showError(error);
            }
        }

        private void closeButton_Click(object sender, System.EventArgs e)
        {
            doCancel = true;
            try
            {
                if( Document != null ) 
                {
                    Document.OnPageProcessed -= pageProcessedHandler;
                    pageProcessedHandler = null;
                    Synchronizer.Document = null;
                    Document.Close();
                    Document = null;
                }
            }
            catch( Exception error )
            {
				showError(error);
			}
			recognizeButton.Enabled = false;
			enableButtonsForTextEditor(false);
		}

        private void enableCommandsAndBasicButtons( bool enable )
        {
            if ( !this.IsHandleCreated )
            {
                return;
            }
            try
            {
                this.imageViewer.Locked = !enable;
                this.documentViewer.Locked = !enable;
                this.textEditor.Locked = !enable;
                this.zoomViewer.Locked = !enable;
                if (validatorForm != null)
                {
                    validatorForm.TextValidator.Locked = !enable;
                }
                openButton.Enabled = enable;
				recognizeButton.Enabled = enable && hasPages(); 
				closeButton.Enabled = enable;
            }
            catch( Exception error ) 
            {
                showError(error);
            }
        }

        private void enableButtonsForTextEditor( bool enable )
        {
            if ( !this.IsHandleCreated )
            {
                return;
            }
            exportButton.Enabled = enable && hasPages();
            validateButton.Enabled = enable && hasPages();
        }

		private bool hasPages()
		{
			return (Document != null) && (Document.Pages.Count > 0);
		}
        private void viewers_onProgress( int percentage, out bool cancel )
        {
            try 
            {
                System.Windows.Forms.Application.DoEvents();
            }
            catch( Exception error ) 
            {
                showError(error);
            }
            cancel = doCancel;
        }

        private void document_pageProcessedHandler( FREngine.FRDocument sender, int index, 
            FREngine.PageProcessingStageEnum stage )
        {
            try
            {
                if( stage == FREngine.PageProcessingStageEnum.PPS_Synthesis ) 
                {
                    enableButtonsForTextEditor( true );
					isTextButtonsEnabled = true;
				}
            }            
            catch( Exception error ) 
            {
                showError(error);
            }
        }

        private void document_OnProgress(FREngine.FRDocument sender, int Percentage, ref bool cancel)
        {
            try
            {
                System.Windows.Forms.Application.DoEvents();
            }
            catch( Exception error ) 
            {
                showError(error);
            }
            cancel = doCancel;
        }

        private void application_onExit(Object sender, EventArgs e)
        {
            try
            {
                unloadEngine();
            }
            catch( Exception error ) 
            {
                showError(error);
            }
        }

        private void showError(Exception error)
        {
            if (this.IsHandleCreated)
            {
                MessageBox.Show(this, error.Message, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            else 
            {
                MessageBox.Show(error.Message);
            }
        }

		private void OnLongOperationStarted(object sender, EventArgs e)
		{
			isTextButtonsEnabled = validateButton.Enabled;
			enableCommandsAndBasicButtons(false);
			enableButtonsForTextEditor(false);
		}

		private void OnLongOperationFinished(object sender, EventArgs e)
		{
			enableCommandsAndBasicButtons(true);
			enableButtonsForTextEditor(isTextButtonsEnabled);
		}

    }
}
